Version bump for both stable and beta versions. This time they use system-login rathe...
authorDiego Elio Pettenò <flameeyes@gentoo.org>
Fri, 7 Mar 2008 13:59:18 +0000 (13:59 +0000)
committerDiego Elio Pettenò <flameeyes@gentoo.org>
Fri, 7 Mar 2008 13:59:18 +0000 (13:59 +0000)
Package-Manager: portage-2.1.4.4

app-admin/sudo/ChangeLog
app-admin/sudo/Manifest
app-admin/sudo/sudo-1.6.8_p12-r1.ebuild
app-admin/sudo/sudo-1.6.9_p14.ebuild [new file with mode: 0644]
app-admin/sudo/sudo-1.7_beta3.ebuild [new file with mode: 0644]

index d2bac3813cbcf6c5d2ff454ae2b6ea370133e490..7d13039dea28ab4c23f6121bef968c4ad4d341a3 100644 (file)
@@ -1,6 +1,15 @@
 # ChangeLog for app-admin/sudo
 # Copyright 2002-2008 Gentoo Foundation; Distributed under the GPL v2
-# $Header: /var/cvsroot/gentoo-x86/app-admin/sudo/ChangeLog,v 1.117 2008/02/25 18:15:48 flameeyes Exp $
+# $Header: /var/cvsroot/gentoo-x86/app-admin/sudo/ChangeLog,v 1.118 2008/03/07 13:59:18 flameeyes Exp $
+
+*sudo-1.7_beta3 (07 Mar 2008)
+*sudo-1.6.9_p14 (07 Mar 2008)
+
+  07 Mar 2008; Diego Pettenò <flameeyes@gentoo.org> +sudo-1.6.9_p14.ebuild,
+  +sudo-1.7_beta3.ebuild:
+  Version bump for both stable and beta versions. This time they use
+  system-login rather than system-auth as basic authentication measure, and
+  they rely on pambase to provide that.
 
   25 Feb 2008; Diego Pettenò <flameeyes@gentoo.org> sudo-1.6.9_p13.ebuild,
   sudo-1.7_beta2.ebuild:
index b65dc0df4b10227db408ade43e39a39195084afa..5f07e05890a6d142d4e55d09fceec8d44fbbaa35 100644 (file)
@@ -9,17 +9,21 @@ AUX sudoers 1612 RMD160 f61c372791112feecae7e0a762a9aa9f30285099 SHA1 b27d644dcd
 DIST sudo-1.6.8p12.tar.gz 585643 RMD160 d7ff9f18ca0973615258c2e975300b94567451d5 SHA1 a79631e9e1c0d0d3f2aa88ae685628e5fde61982 SHA256 56f7d86032538a4a98d90af3742903a09ba16d6db82b593e4a47605f87fa581a
 DIST sudo-1.6.9p12.tar.gz 581936 RMD160 fe07ead5c328b35fc0c84946d71469f4620ddd06 SHA1 c2b07c68d2026fb3e7786b2c9a8fb0c519a830f8 SHA256 d25c7a04f0db65c4a4e587df337fb6c4bd5165155d7ab64e8b00a89f745dd4aa
 DIST sudo-1.6.9p13.tar.gz 589079 RMD160 eb2a4d835553061f9a15d71abee83a5574215c28 SHA1 0e84a265bb18772bc99d0f37c65dd6564962a6c4 SHA256 c54b8f10eca330cb3181e4a16bd743b145d4fcf9d1d85df6127d7e9979d4a805
+DIST sudo-1.6.9p14.tar.gz 589298 RMD160 8516c9f0a6468e07174ffda310f55013841e3fba SHA1 71ac10f51c1b3d6338ac936fe39be3009ea4dbb4 SHA256 cffccc9090df1daf3aba129f94bf5e01724e723e3264124b9d57d4a1437f097a
 DIST sudo-1.7b2.tar.gz 711994 RMD160 aaec1acc7274ce6c2564768321947eab42c10a42 SHA1 83422e1be04498052a456c88abbaa5e64d9703b7 SHA256 ca5872d45f70d4890f7ba15fd506580043fcb4f528856a1f76a44057cbd263bf
-EBUILD sudo-1.6.8_p12-r1.ebuild 6604 RMD160 ef6f24a0e1e53a2b0e1aa359119f48576daa4e70 SHA1 7f3cffc38831243bf48e2af4078127cf627ad860 SHA256 278289085ee91f0b63ce8af6a474e8026f55bc11a3e06673f82e07f6801ffa25
+DIST sudo-1.7b3.tar.gz 734143 RMD160 753eb5dcc0dc4e71ff4f8a074583bec9784a696c SHA1 f76af7f9ef8eb098c98b3b549ea49691a0cf9b16 SHA256 6141ae32d639a4d0c883b3d4f6f5876c2f36d495fedfea20b539dd9c89c48c00
+EBUILD sudo-1.6.8_p12-r1.ebuild 6599 RMD160 033bebdfad4d67e96572b6a4c4fa918c04f54e3a SHA1 38e9cae0c5cdfd04608790e14c6936c392747915 SHA256 74c1b9bff370d9e7040e10ede8347676d419ed6c73793426b6cfc8abfa89fe78
 EBUILD sudo-1.6.9_p12.ebuild 5840 RMD160 f72c7fcad3769de48ec41181ad2c513ba5a01250 SHA1 a39c311f143c459011e34303db53a5157eeec055 SHA256 ae34dd669d9ce86feac16754dc7f541b8c4bb112a1fc6a8b2d3014a01393ea19
 EBUILD sudo-1.6.9_p13.ebuild 5889 RMD160 c062903f85a9f75e336afad00057b0f540818026 SHA1 8d9575111f0dba3cae19d46b9e4f4280118309bb SHA256 90b6804d0a78e7a3de252c42c09e3f2a669eadc2a37c5f58e000506738f40930
+EBUILD sudo-1.6.9_p14.ebuild 5910 RMD160 f8c74d19a830be384e0f1f555ca5c9f6519fb9b3 SHA1 c4e58bdd297504c677f546cd35b668f3a43c421f SHA256 fee484649a4aff6ebb596e6d4b73b546661e19ce2a63e8234de409fa3af61043
 EBUILD sudo-1.7_beta2.ebuild 6315 RMD160 158c235d44673da192d634d2c4ea6626a0303222 SHA1 dca682f6f5874b1fb4049e8197351bd3c62cc3d5 SHA256 add857afe38e8ec7bb2c3210dbd98a5df4115bcc876bdc66f35065ba7b1548e2
-MISC ChangeLog 15843 RMD160 19eb8b3648ee64c986f0d6a3be5c5797454b182d SHA1 beb482c13481f8df3ca8d2bc54df8f9382cc3384 SHA256 2d0ffed53e0db73ccffb9a1669a3c14c496988dbda6cb346220d8ded38f0361e
+EBUILD sudo-1.7_beta3.ebuild 6336 RMD160 53f56e248ff1a5ba3b063624c16174dab13637b6 SHA1 23b7172ae231908018abe50f2406819ff7cf96cc SHA256 f2013e50f7a45a44c4c9bce9dfde85d2cce855ca1bcc62289d5038a20576db61
+MISC ChangeLog 16193 RMD160 0693a49b1911dc9dbd664abcbe648c5a184f09dc SHA1 5b972d746eb7a61db64959dfb95ade3ff96e629a SHA256 2006e634c03dd222565c65d75c76f0efb7341d2ef79b883e672909c1d3f0e793
 MISC metadata.xml 501 RMD160 74dd36daa51d7ad5ce1659f0279e1245cd1ef4bc SHA1 e447d21dc61ee4a6de8cc0f66aa28aa422d9990a SHA256 5f399b83a90977486ff92847caa884d16f8b71705fd0d2203acb35f56c9a6db6
 -----BEGIN PGP SIGNATURE-----
 Version: GnuPG v2.0.7 (GNU/Linux)
 
-iD8DBQFHwwXbAiZjviIA2XgRAkthAKCEE1QsIr5Q1Kh5OoNwUFS67AW9DgCg2aIi
-EO+o086j9QrTjiWB6nO9HoY=
-=gTHA
+iD8DBQFH0UpHAiZjviIA2XgRAqe+AJsES300qeJctDsVgERTMpV9shHv5QCZARWo
+JzPlY31wdQFgdbnhKvLHd0U=
+=YyNa
 -----END PGP SIGNATURE-----
index df882fab94768aaeb8c9accf9738958843cfa8cc..0f5181d33495460061d5a17dfdd00005af17d734 100644 (file)
@@ -1,6 +1,6 @@
 # Copyright 1999-2008 Gentoo Foundation
 # Distributed under the terms of the GNU General Public License v2
-# $Header: /var/cvsroot/gentoo-x86/app-admin/sudo/sudo-1.6.8_p12-r1.ebuild,v 1.17 2008/02/20 00:35:52 flameeyes Exp $
+# $Header: /var/cvsroot/gentoo-x86/app-admin/sudo/sudo-1.6.8_p12-r1.ebuild,v 1.18 2008/03/07 13:59:18 flameeyes Exp $
 
 inherit eutils pam
 
@@ -11,7 +11,7 @@ HOMEPAGE="http://www.sudo.ws/"
 SRC_URI="ftp://ftp.sudo.ws/pub/sudo/${P/_/}.tar.gz"
 LICENSE="Sudo"
 SLOT="0"
-KEYWORDS="alpha amd64 arm hppa ia64 m68k mips ppc ppc64 s390 sh sparc ~sparc-fbsd x86 ~x86-fbsd"
+KEYWORDS="alpha amd64 arm hppa ia64 m68k ppc ppc64 s390 sh sparc ~sparc-fbsd x86 ~x86-fbsd"
 IUSE="pam skey offensive ldap selinux"
 
 DEPEND="pam? ( || ( virtual/pam sys-libs/pam ) )
diff --git a/app-admin/sudo/sudo-1.6.9_p14.ebuild b/app-admin/sudo/sudo-1.6.9_p14.ebuild
new file mode 100644 (file)
index 0000000..b09fd19
--- /dev/null
@@ -0,0 +1,188 @@
+# Copyright 1999-2008 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/app-admin/sudo/sudo-1.6.9_p14.ebuild,v 1.1 2008/03/07 13:59:18 flameeyes Exp $
+
+inherit eutils pam confutils
+
+DESCRIPTION="Allows users or groups to run commands as other users"
+HOMEPAGE="http://www.sudo.ws/"
+SRC_URI="ftp://ftp.sudo.ws/pub/sudo/${P/_/}.tar.gz"
+LICENSE="Sudo"
+SLOT="0"
+KEYWORDS="~alpha ~arm ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~sparc-fbsd ~x86 ~x86-fbsd"
+IUSE="pam skey offensive ldap selinux"
+
+DEPEND="pam? ( virtual/pam )
+       ldap? ( >=net-nds/openldap-2.1.30-r1 )
+       skey? ( >=app-admin/skey-1.1.5-r1 )
+       virtual/editor
+       virtual/mta"
+RDEPEND="selinux? ( sec-policy/selinux-sudo )
+       ldap? ( dev-lang/perl )
+       pam? ( sys-auth/pambase )
+       ${DEPEND}"
+DEPEND="${RDEPEND} sys-devel/bison"
+
+S=${WORKDIR}/${P/_/}
+
+pkg_setup() {
+       confutils_use_conflict skey pam
+}
+
+src_unpack() {
+       unpack ${A}; cd "${S}"
+
+       # compatability fix.
+       epatch "${FILESDIR}"/${PN}-skeychallengeargs.diff
+
+       # additional variables to disallow, should user disable env_reset.
+
+       # NOTE: this is not a supported mode of operation, these variables
+       #       are added to the blacklist as a convenience to administrators
+       #       who fail to heed the warnings of allowing untrusted users
+       #       to access sudo.
+       #
+       #       there is *no possible way* to foresee all attack vectors in
+       #       all possible applications that could potentially be used via
+       #       sudo, these settings will just delay the inevitable.
+       #
+       #       that said, I will accept suggestions for variables that can
+       #       be misused in _common_ interpreters or libraries, such as
+       #       perl, bash, python, ruby, etc., in the hope of dissuading
+       #       a casual attacker.
+
+       # XXX: perl should be using suid_perl.
+       # XXX: users can remove/add more via env_delete and env_check.
+       # XXX: <?> = probably safe enough for most circumstances.
+
+       einfo "Blacklisting common variables (env_delete)..."
+               sudo_bad_var 'PERLIO_DEBUG'   # perl, write debug to file.
+               sudo_bad_var 'FPATH'          # ksh, search path for functions.
+               sudo_bad_var 'NULLCMD'        # zsh, command on null-redir. <?>
+               sudo_bad_var 'READNULLCMD'    # zsh, command on null-redir. <?>
+               sudo_bad_var 'GLOBIGNORE'     # bash, glob paterns to ignore. <?>
+               sudo_bad_var 'PYTHONHOME'     # python, module search path.
+               sudo_bad_var 'PYTHONPATH'     # python, search path.
+               sudo_bad_var 'PYTHONINSPECT'  # python, allow inspection.
+               sudo_bad_var 'RUBYLIB'        # ruby, lib load path.
+               sudo_bad_var 'RUBYOPT'        # ruby, cl options.
+               sudo_bad_var 'ZDOTDIR'        # zsh, path to search for dotfiles.
+       einfo "...done."
+
+       # prevent binaries from being stripped.
+       sed -i 's/\($(INSTALL).*\) -s \(.*[(sudo|visudo)]\)/\1 \2/g' Makefile.in
+
+       # remove useless c++ checks
+       epunt_cxx
+}
+
+src_compile() {
+       local line ROOTPATH
+
+       # FIXME: secure_path is a compile time setting. using ROOTPATH
+       # is not perfect, env-update may invalidate this, but until it
+       # is available as a sudoers setting this will have to do.
+       einfo "Setting secure_path..."
+
+               # why not use grep? variable might be expanded from other variables
+               # declared in that file. cannot just source the file, would override
+               # any variables already set.
+               eval `PS4= bash -x /etc/profile.env 2>&1 | \
+                       while read line; do
+                               case $line in
+                                       ROOTPATH=*) echo $line; break;;
+                                       *) continue;;
+                               esac
+                       done`  && einfo "       Found ROOTPATH..." || \
+                               ewarn " Failed to find ROOTPATH, please report this."
+
+               # remove any duplicate entries
+               ROOTPATH=$(cleanpath /bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:/opt/bin${ROOTPATH:+:${ROOTPATH}})
+
+               # strip gcc path (bug #136027)
+               rmpath ROOTPATH '*/gcc-bin/*'
+
+       einfo "...done."
+
+       # XXX: --disable-path-info closes an info leak, but may be confusing.
+       # XXX: /bin/vi may not be available, make nano visudo's default.
+       econf --with-secure-path="${ROOTPATH}" \
+               --with-editor=/bin/nano \
+               --with-env-editor \
+               $(use_with offensive insults) \
+               $(use_with offensive all-insults) \
+               $(use_with pam) \
+               $(use_with skey) \
+               $(use_with ldap ldap_conf_file /etc/ldap.conf.sudo) \
+               $(use_with ldap) || die
+
+       emake || die
+}
+
+src_install() {
+       emake -j1 DESTDIR="${D}" install || die
+       dodoc BUGS CHANGES HISTORY PORTING README TROUBLESHOOTING \
+               UPGRADE sample.sudoers sample.syslog.conf
+
+       if use ldap; then
+               dodoc README.LDAP schema.OpenLDAP
+               dosbin sudoers2ldif
+
+               cat - > "${T}"/ldap.conf.sudo <<EOF
+# See ldap.conf(5) and README.LDAP for details\n"
+# This file should only be readable by root\n\n"
+# supported directives: host, port, ssl, ldap_version\n"
+# uri, binddn, bindpw, sudoers_base, sudoers_debug\n"
+# tls_{checkpeer,cacertfile,cacertdir,randfile,ciphers,cert,key
+EOF
+
+               insinto /etc
+               doins "${T}"/ldap.conf.sudo
+               fperms 0440 /etc/ldap.conf.sudo
+       fi
+
+       pamd_mimic system-login sudo auth account password session
+
+       insinto /etc
+       doins "${FILESDIR}"/sudoers
+       fperms 0440 /etc/sudoers
+}
+
+# remove duplicate path entries from $1
+cleanpath() {
+       local i=1 x n IFS=:
+       local -a paths; paths=($1)
+
+       for ((n=${#paths[*]}-1;i<=n;i++)); do
+               for ((x=0;x<i;x++)); do
+                       test "${paths[i]}" == "${paths[x]}" && {
+                               einfo " Duplicate entry ${paths[i]} removed..." 1>&2
+                               unset paths[i]; continue 2; }
+               done; # einfo " Adding ${paths[i]}..." 1>&2
+       done; echo "${paths[*]}"
+}
+
+# add $1 to default env_delete list.
+sudo_bad_var() {
+       local target='env.c' marker='\*initial_badenv_table\[\]'
+
+       ebegin "        $1"
+               sed -i 's#\(^.*'${marker}'.*$\)#\1\n\t"'${1}'",#' "${S}"/${target}
+       eend $?
+}
+
+rmpath() {
+       declare e newpath oldpath=${!1} PATHvar=$1 thisp IFS=:
+       shift
+       for thisp in $oldpath; do
+               for e; do [[ $thisp == $e ]] && continue 2; done
+               newpath=$newpath:$thisp
+       done
+       eval $PATHvar='${newpath#:}'
+}
+
+pkg_postinst() {
+       use ldap && {
+               ewarn "sudo uses the /etc/ldap.conf.sudo file for ldap configuration."
+       }
+}
diff --git a/app-admin/sudo/sudo-1.7_beta3.ebuild b/app-admin/sudo/sudo-1.7_beta3.ebuild
new file mode 100644 (file)
index 0000000..02e993a
--- /dev/null
@@ -0,0 +1,201 @@
+# Copyright 1999-2008 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/app-admin/sudo/sudo-1.7_beta3.ebuild,v 1.1 2008/03/07 13:59:18 flameeyes Exp $
+
+inherit eutils pam confutils
+
+MY_P=${P/_/}
+MY_P=${MY_P/beta/b}
+
+[[ ${P} == *_beta* ]] && uri_prefix=beta/ || uri_prefix=""
+
+DESCRIPTION="Allows users or groups to run commands as other users"
+HOMEPAGE="http://www.sudo.ws/"
+SRC_URI="ftp://ftp.sudo.ws/pub/sudo/${uri_prefix}${MY_P}.tar.gz"
+LICENSE="Sudo"
+SLOT="0"
+KEYWORDS="~alpha ~arm ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~sparc-fbsd ~x86 ~x86-fbsd"
+IUSE="pam skey offensive ldap selinux"
+
+DEPEND="pam? ( virtual/pam )
+       ldap? ( >=net-nds/openldap-2.1.30-r1 )
+       skey? ( >=app-admin/skey-1.1.5-r1 )
+       virtual/editor
+       virtual/mta"
+RDEPEND="selinux? ( sec-policy/selinux-sudo )
+       ldap? ( dev-lang/perl )
+       pam? ( sys-auth/pambase )
+       ${DEPEND}"
+DEPEND="${RDEPEND} sys-devel/bison"
+
+S=${WORKDIR}/${MY_P}
+
+pkg_setup() {
+       confutils_use_conflict skey pam
+}
+
+src_unpack() {
+       unpack ${A}; cd "${S}"
+
+       # compatability fix.
+       epatch "${FILESDIR}"/${PN}-skeychallengeargs.diff
+
+       # additional variables to disallow, should user disable env_reset.
+
+       # NOTE: this is not a supported mode of operation, these variables
+       #       are added to the blacklist as a convenience to administrators
+       #       who fail to heed the warnings of allowing untrusted users
+       #       to access sudo.
+       #
+       #       there is *no possible way* to foresee all attack vectors in
+       #       all possible applications that could potentially be used via
+       #       sudo, these settings will just delay the inevitable.
+       #
+       #       that said, I will accept suggestions for variables that can
+       #       be misused in _common_ interpreters or libraries, such as
+       #       perl, bash, python, ruby, etc., in the hope of dissuading
+       #       a casual attacker.
+
+       # XXX: perl should be using suid_perl.
+       # XXX: users can remove/add more via env_delete and env_check.
+       # XXX: <?> = probably safe enough for most circumstances.
+
+       einfo "Blacklisting common variables (env_delete)..."
+               sudo_bad_var() {
+                       local target='env.c' marker='\*initial_badenv_table\[\]'
+
+                       ebegin "        $1"
+                       sed -i 's#\(^.*'${marker}'.*$\)#\1\n\t"'${1}'",#' "${S}"/${target}
+                       eend $?
+               }
+
+               sudo_bad_var 'PERLIO_DEBUG'   # perl, write debug to file.
+               sudo_bad_var 'FPATH'          # ksh, search path for functions.
+               sudo_bad_var 'NULLCMD'        # zsh, command on null-redir. <?>
+               sudo_bad_var 'READNULLCMD'    # zsh, command on null-redir. <?>
+               sudo_bad_var 'GLOBIGNORE'     # bash, glob paterns to ignore. <?>
+               sudo_bad_var 'PYTHONHOME'     # python, module search path.
+               sudo_bad_var 'PYTHONPATH'     # python, search path.
+               sudo_bad_var 'PYTHONINSPECT'  # python, allow inspection.
+               sudo_bad_var 'RUBYLIB'        # ruby, lib load path.
+               sudo_bad_var 'RUBYOPT'        # ruby, cl options.
+               sudo_bad_var 'ZDOTDIR'        # zsh, path to search for dotfiles.
+       einfo "...done."
+
+       # prevent binaries from being stripped.
+       sed -i 's/\($(INSTALL).*\) -s \(.*[(sudo|visudo)]\)/\1 \2/g' Makefile.in
+
+       # remove useless c++ checks
+       epunt_cxx
+}
+
+src_compile() {
+       local line ROOTPATH
+
+       # FIXME: secure_path is a compile time setting. using ROOTPATH
+       # is not perfect, env-update may invalidate this, but until it
+       # is available as a sudoers setting this will have to do.
+       einfo "Setting secure_path..."
+
+               # why not use grep? variable might be expanded from other variables
+               # declared in that file. cannot just source the file, would override
+               # any variables already set.
+               eval `PS4= bash -x /etc/profile.env 2>&1 | \
+                       while read line; do
+                               case $line in
+                                       ROOTPATH=*) echo $line; break;;
+                                       *) continue;;
+                               esac
+                       done`  && einfo "       Found ROOTPATH..." || \
+                               ewarn " Failed to find ROOTPATH, please report this."
+
+               # remove duplicate path entries from $1
+               cleanpath() {
+                       local i=1 x n IFS=:
+                       local -a paths; paths=($1)
+
+                       for ((n=${#paths[*]}-1;i<=n;i++)); do
+                               for ((x=0;x<i;x++)); do
+                                       test "${paths[i]}" == "${paths[x]}" && {
+                                               einfo " Duplicate entry ${paths[i]} removed..." 1>&2
+                                               unset paths[i]; continue 2; }
+                               done; # einfo " Adding ${paths[i]}..." 1>&2
+                       done; echo "${paths[*]}"
+               }
+
+               ROOTPATH=$(cleanpath /bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:/opt/bin${ROOTPATH:+:${ROOTPATH}})
+
+               # strip gcc path (bug #136027)
+               rmpath() {
+                       declare e newpath oldpath=${!1} PATHvar=$1 thisp IFS=:
+                       shift
+                       for thisp in $oldpath; do
+                               for e; do [[ $thisp == $e ]] && continue 2; done
+                               newpath=$newpath:$thisp
+                       done
+                       eval $PATHvar='${newpath#:}'
+               }
+
+               rmpath ROOTPATH '*/gcc-bin/*'
+
+       einfo "...done."
+
+       # XXX: --disable-path-info closes an info leak, but may be confusing.
+       # XXX: /bin/vi may not be available, make nano visudo's default.
+       econf --with-secure-path="${ROOTPATH}" \
+               --with-editor=/bin/nano \
+               --with-env-editor \
+               $(use_with offensive insults) \
+               $(use_with offensive all-insults) \
+               $(use_with pam) \
+               $(use_with skey) \
+               $(use_with ldap ldap_conf_file /etc/ldap.conf.sudo) \
+               $(use_with ldap) || die
+
+       emake || die
+}
+
+src_install() {
+       emake -j1 DESTDIR="${D}" install || die
+       dodoc ChangeLog HISTORY PORTING README TROUBLESHOOTING \
+               UPGRADE sample.sudoers sample.syslog.conf
+
+       if use ldap; then
+               dodoc README.LDAP schema.OpenLDAP
+               dosbin sudoers2ldif
+
+               cat - > "${T}"/ldap.conf.sudo <<EOF
+# See ldap.conf(5) and README.LDAP for details\n"
+# This file should only be readable by root\n\n"
+# supported directives: host, port, ssl, ldap_version\n"
+# uri, binddn, bindpw, sudoers_base, sudoers_debug\n"
+# tls_{checkpeer,cacertfile,cacertdir,randfile,ciphers,cert,key
+EOF
+
+               insinto /etc
+               doins "${T}"/ldap.conf.sudo
+               fperms 0440 /etc/ldap.conf.sudo
+       fi
+
+       pamd_mimic system-login sudo auth account password session
+
+       insinto /etc
+       doins "${FILESDIR}"/sudoers
+       fperms 0440 /etc/sudoers
+}
+
+pkg_postinst() {
+       if use ldap; then
+               ewarn
+               ewarn "sudo uses the /etc/ldap.conf.sudo file for ldap configuration."
+               ewarn
+               if egrep -q '^[[:space:]]*sudoers:' "${ROOT}"/etc/nsswitch.conf; then
+                       ewarn "In 1.7 series, LDAP is no more consulted, unless explicitly"
+                       ewarn "configured in /etc/nsswitch.conf."
+                       ewarn
+                       ewarn "To make use of LDAP, add this line to your /etc/nsswitch.conf:"
+                       ewarn "  sudoers: ldap files"
+                       ewarn
+               fi
+       fi
+}